/*
 * This file is part of Rahmenwerk.
 *
 * Rahmenwerk is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License  as 
 * published by the Free Software Foundation, either version 3 of the
 * License.
 *
 * Rahmenwerk is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with Rahmenwerk.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * 
 *
 * Copyright (c) 2011 SWARCO TRAFFIC SYSTEMS GmbH.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 * SWARCO TRAFFIC SYSTEMS GmbH - initial API and implementation
 *
 *
 *
 * Contact Information:
 * SWARCO TRAFFIC SYSTEMS GmbH
 * Adolf-Dambach-Strae 
 * D-76571 Gaggenau
 * Phone: +49-7225-64-03
 * Fax: +49-7225-64-300
 * mailto: office.sts@swarco.de
 */

package de.bsvrz.buv.plugin.konfigass;

//~ NICHT JDK IMPORTE =========================================================

//import de.inovat.buv.plugin.lib.beispiel.Activator;
import java.util.Map;

import org.eclipse.core.runtime.IStatus;
import org.eclipse.swt.SWT;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.ui.PlatformUI;
import org.eclipse.ui.part.ViewPart;

import de.inovat.buv.plugin.lib.debug.ProtokollGUI;
import de.inovat.buv.plugin.lib.debug.ProtokollGUIVerwaltung;

//~ KLASSEN ===================================================================

/**
 * Beispiel der Verwendung des Protokoll-GUI.
 *
 * @author inovat
 * @author Liliya Givorgizova (LG)
 * @version $Revision: 1.7 $ / $Date: 2011/02/02 15:47:12 $ / ($Author: Sans $)
 */
public class ErrorView extends ViewPart {
    public static final String ID = "de.bsvrz.buv.plugin.konfigass.errorview";

    //~ FELDER ================================================================

    /** Instanz der Protokoll-GUI-Verwaltung. */
    private ProtokollGUIVerwaltung _protokoll;

    //~ KONSTRUKTOREN  (und vom Konstruktor verwendete Methoden) ==============

    /**
     * Erzeugt eine Instanz der Klasse View.
     */
    public ErrorView() {}

    //~ METHODEN ==============================================================

    private Composite _parent;
    
    @Override
    public void createPartControl(Composite parent) {
      
        _parent = parent;
        //Fr die F1 Taste
        PlatformUI.getWorkbench().getHelpSystem().setHelp(_parent, "de.bsvrz.buv.plugin.konfigass" + ".meldungen" );
      
        parent.setLayout(new GridLayout(1, false));

        final Composite composite = new Composite(parent, SWT.NONE);

        composite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
        composite.setLayout(new GridLayout(1, false));

        // Zeige Protokoll-GUI:
        Map<IStatus, Object[]> listeMeldungen = MeldungenSpeicher.getInstanz().getlMultiMeldungen();
        
        
        ProtokollGUI protokollGui = new ProtokollGUI(composite, listeMeldungen);

        // Hole die Protokoll-GUI-Verwaltung Instanz:
        _protokoll = protokollGui.getGuiVew();

        //
//        final Group grp = new Group(parent, SWT.NONE);
//
//        grp.setText("Testmeldungen erstellen");
//        grp.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
//        grp.setLayout(new GridLayout(1, false));
//
//        final Button btnHinzufuegen = new Button(grp, SWT.NONE);
//
//        btnHinzufuegen.setText("Meldung hinzufgen");
//        btnHinzufuegen.addSelectionListener(new SelectionAdapter() {
//            @Override
//            public void widgetSelected(SelectionEvent e) {
//
//                // Erstelle eine Meldung und zeige die im Protokoll.
//                IStatus fehlerMeldung = null;
//
//                try {
//                    int i = 8 / 0;
//                }
//                catch (Exception e2) {
//                    fehlerMeldung = Log.erzeugeMeldung(Log.FEHLER, Activator.PLUGIN_ID, "Es ist ein Fehler aufgetreten!", e2);
//                }
//
//                List<IStatus> liste = new ArrayList<IStatus>();
//
//                if (fehlerMeldung != null) {
//                    liste.add(fehlerMeldung);
//                }
//
//                IStatus meldung = Log.erzeugeMultiMeldung(Activator.PLUGIN_ID, "Testmeldung", liste);
//
//                _protokoll.hinzufuegenMeldung(meldung);
//            }
//        });
    }

    //~ GET METHODEN ==========================================================

    /**
     * Liefert das Protokollobjekt, ber das Meldungen verwaltet werden.
     * @return Das Protokollobjekt, ber das Meldungen verwaltet werden.
     */
    public ProtokollGUIVerwaltung getProtokoll() {
        return _protokoll;
    }

    //~ SET METHODEN ==========================================================

//    @Override
//    public void setFocus() {}

  @Override
  public void setFocus()
  {
    //Fr die F1 Taste
    if (_parent != null)
      _parent.setFocus();
  
  }
}  
//~Formatiert mit 'inovat Kodierkonvention' am 16.04.10
