/*
 * This file is part of Rahmenwerk.
 *
 * Rahmenwerk is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License  as 
 * published by the Free Software Foundation, either version 3 of the
 * License.
 *
 * Rahmenwerk is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with Rahmenwerk.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * 
 *
 * Copyright (c) 2011 SWARCO TRAFFIC SYSTEMS GmbH.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 * SWARCO TRAFFIC SYSTEMS GmbH - initial API and implementation
 *
 *
 *
 * Contact Information:
 * SWARCO TRAFFIC SYSTEMS GmbH
 * Adolf-Dambach-Strae 
 * D-76571 Gaggenau
 * Phone: +49-7225-64-03
 * Fax: +49-7225-64-300
 * mailto: office.sts@swarco.de
 */

package de.bsvrz.buv.plugin.konfigass.assistenten;

import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.jface.wizard.Wizard;
import org.eclipse.ui.IWorkbench;

import de.bsvrz.puk.config.configFile.datamodel.ConfigDataModel;

/**
 * Wizard class
 */
public class KvAoeNeuAssistent extends Wizard /* implements INewWizard */
{
  public static final String copyright = "(c) Copyright IBM Corporation 2002.";

  // wizard pages
  KvAoeNeuStartSeite seiteStart;

  KvAoeNeuSeite1 seite1;

  KvAoeNeuSeite2 seite2;

  KvAoeNeuSeite3 seite3;

  // the model
  KvAoeNeuModell model;

  // workbench selection when the wizard was started
  protected IStructuredSelection selection;

  // flag indicated whether the wizard can be completed or not
  protected boolean seiteStartComplete = false;

  // flag indicated whether the wizard can be completed or not
  protected boolean seite1Complete = false;

  // flag indicated whether the wizard can be completed or not
  protected boolean seite2Complete = false;

  // flag indicated whether the wizard can be completed or not
  protected boolean seite3Complete = false;

  // the workbench instance
  protected IWorkbench workbench;

  private ConfigDataModel _dataModel;

  /**
   * Constructor for HolidayMainWizard.
   */
  public KvAoeNeuAssistent(IWorkbench workbench, ConfigDataModel dataModel)
  {
    super();
    _dataModel = dataModel;
    model = new KvAoeNeuModell();
    this.workbench = workbench;
    setNeedsProgressMonitor(true);
  }

  public void addPages()
  {
    seiteStart = new KvAoeNeuStartSeite("");
    addPage(seiteStart);

    seite1 = new KvAoeNeuSeite1("");
    addPage(seite1);
    seite2 = new KvAoeNeuSeite2("");
    addPage(seite2);
    seite3 = new KvAoeNeuSeite3("");
    addPage(seite3);

  }

  public boolean canFinish()
  {
    // cannot complete the wizard from the first page
    if (getContainer().getCurrentPage() == seiteStart)
      return false;
    
    return super.canFinish();
  }

  public boolean performFinish()
  {    
    return true;
  }

  public KvAoeNeuModell getModel()
  {
    // TODO Auto-generated method stub
    return this.model;
  }

  public void setModel(KvAoeNeuModell model)
  {
    this.model = model;
  }
 
}
