/*
 * This file is part of Rahmenwerk.
 *
 * Rahmenwerk is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License  as 
 * published by the Free Software Foundation, either version 3 of the
 * License.
 *
 * Rahmenwerk is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with Rahmenwerk.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * 
 *
 * Copyright (c) 2011 SWARCO TRAFFIC SYSTEMS GmbH.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 * SWARCO TRAFFIC SYSTEMS GmbH - initial API and implementation
 *
 *
 *
 * Contact Information:
 * SWARCO TRAFFIC SYSTEMS GmbH
 * Adolf-Dambach-Strae 
 * D-76571 Gaggenau
 * Phone: +49-7225-64-03
 * Fax: +49-7225-64-300
 * mailto: office.sts@swarco.de
 */

package de.bsvrz.buv.plugin.konfigass.preferences;

import java.io.File;

import org.eclipse.jface.resource.ImageDescriptor;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.events.SelectionListener;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.DirectoryDialog;
import org.eclipse.swt.widgets.FileDialog;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.MessageBox;
import org.eclipse.swt.widgets.Text;
import org.eclipse.ui.IWorkbench;
import org.eclipse.ui.IWorkbenchPreferencePage;
import org.eclipse.ui.PlatformUI;
import org.eclipse.ui.help.IWorkbenchHelpSystem;

import de.bsvrz.buv.plugin.konfigass.Activator;

/**
 * Legt fest, wie lange beim Beenden des Rahmenwerkes gewartet werden soll und
 * unter welchen Betriebssystemen gewartet werden soll.
 * 
 * @author HofmannJ
 * 
 */
public class PreferencePage extends org.eclipse.jface.preference.PreferencePage
		implements IWorkbenchPreferencePage {
	/**
	 * ID der PreferencePage
	 */
	public static final String ID = "de.bsvrz.buv.plugin.konfigass.preferencePage";
	private Label label = null;
	private Button _button = null;
	private Group _grpEin;
	private Button _chkSoundVerwenden;
	private Text _textDatei;
	// private Text _textUser;
	// private Text _textPasswd;
	private Composite _top;
  private Group _grpBasis;
  private Text _textVerzeichnis;
  private Button _button2;

	public PreferencePage() {
		setPreferenceStore(Activator.getDefault().getPreferenceStore());

//		String msg = "";
//		msg = msg + "Mit Hilfe dieser Preferencepage knnen Einstellungen bzgl. des Plugins\n";
//		msg = msg + "Konfigurationsassistent vorgenommen werden\n";
//		msg = msg + "Hierbei knnen die XML-Verwaltungsdatei sowie die zu verwendende Konfiguration\n";
//	  msg = msg + "eingestellt werden\n";
//		setDescription(msg);
	}

	public PreferencePage(String title) {
		super(title);
	}

	public PreferencePage(String title, ImageDescriptor image) {
		super(title, image);
	}

	@Override
	protected Control createContents(Composite parent) {
//		_top = new Composite(parent, SWT.NONE);
//		// Shell top = new Shell();
//    _grpBasis = new Group(_top, SWT.NONE);
//    _grpBasis.setText("Basisverzeichnis:");
//
//    Label label1 = new Label(_grpBasis, SWT.NONE);
//    label1.setText("Verzeichnis:");
//
//    _textVerzeichnis = new Text(_grpBasis, SWT.BORDER);
//
//    Label label2 = new Label(_grpBasis, SWT.NONE);
//    label2.setText("Auswahl:");
//    _button2 = new Button(_grpBasis, SWT.NONE);
//    _button2.setText("Browse");
//    _button2.addMouseListener(new MouseAdapter() {
//      @Override
//      public void mouseDown(MouseEvent e) {
//        DirectoryDialog dd = new DirectoryDialog(PlatformUI
//            .getWorkbench().getDisplay().getActiveShell(), SWT.OPEN);
//        dd.setText("Basisverzeichnis-Auswahl");
//        dd.setMessage("Verzeichnis auswhlen");
//
//        String directoryPath = dd.open();
//        if (directoryPath != null && directoryPath.length() > 0)
//          _textVerzeichnis.setText(directoryPath);
//      }
//    });
//		
//		
//
//		_grpEin = new Group(_top, SWT.NONE);
//		_grpEin.setText("Verwaltungsdatei:");
//
//		Label labelWarteZeit = new Label(_grpEin, SWT.NONE);
//		labelWarteZeit.setText("Eigene XML-Verwaltungsdatei verwenden: ");
//
//		_chkSoundVerwenden = new Button(_grpEin, SWT.CHECK);
//		Label filler = new Label(_grpEin, SWT.NONE);
//		Label filler1 = new Label(_grpEin, SWT.NONE);
//		_chkSoundVerwenden.addSelectionListener(new SelectionListener() {
//
//			@Override
//			public void widgetDefaultSelected(SelectionEvent e) {
//				// TODO Auto-generated method stub
//
//			}
//
//			@Override
//			public void widgetSelected(SelectionEvent e) {
//				// TODO Auto-generated method stub
//				Button b = (Button) e.widget;
//				if (b != null) {
//					if (!b.getSelection()) {
//						_textDatei.setEnabled(false);
////						_compositeZeitDauer.setEnabled(false);
//						_button.setEnabled(false);
//						// _textUser.setEnabled(false);
//						// _textPasswd.setEnabled(false);
//					} else {
//						_textDatei.setEnabled(true);
////						_compositeZeitDauer.setEnabled(true);
//						_button.setEnabled(true);
//						// _textUser.setEnabled(true);
//						// _textPasswd.setEnabled(true);
//					}
//
//				}
//
//			}
//		});
//
//		Label labelServer = new Label(_grpEin, SWT.NONE);
//		labelServer.setText("XML-Verwaltungsdatei:");
//
//		_textDatei = new Text(_grpEin, SWT.BORDER);
//
//		label = new Label(_grpEin, SWT.NONE);
//		label.setText("Dateiauswahl:");
//		_button = new Button(_grpEin, SWT.NONE);
//		_button.setText("Browse");
//		_button.addMouseListener(new MouseAdapter() {
//			@Override
//			public void mouseDown(MouseEvent e) {
//				FileDialog fld = new FileDialog(PlatformUI.getWorkbench()
//						.getDisplay().getActiveShell(), SWT.OPEN);
//				fld.setText("XML-Verwaltungsdatei Datei auswhlen");
//				fld.setFilterNames(new String[] { "XML-Datei", "MP3 Datei" });
//				fld.setFilterExtensions(new String[] { "*.xml" });
//
//				String filePath = fld.open();
//				if (filePath != null && filePath.length() > 0)
//					_textDatei.setText(filePath);
//			}
//		});
//
////		Label labelUser = new Label(_grpEin, SWT.NONE);
////		labelUser.setText("Intervall:");
//
////		_compositeZeitDauer = new MyCompositeZeitDauer(_grpEin, SWT.NONE,
////				new Date().getTime(), true);
//		// _textUser = new Text(_grpEin, SWT.BORDER);
////		Label filler2 = new Label(_grpEin, SWT.NONE);
////		Label filler3 = new Label(_grpEin, SWT.NONE);
//
//		// Label labelPasswd = new Label(_grpEin, SWT.NONE);
//		// labelPasswd.setText("Passwort: ");
//		//
//		// _textPasswd = new Text(_grpEin, SWT.BORDER | SWT.PASSWORD);
//		
//
//		
//		
//
//		/*
//		 * Layout
//		 */
//		GridData gdTop = new GridData();
//		gdTop.grabExcessHorizontalSpace = true;
//		gdTop.horizontalAlignment = GridData.FILL;
//		// gdTop.grabExcessVerticalSpace = true;
//		// gdTop.verticalAlignment = GridData.FILL;
//		_top.setLayoutData(gdTop);
//
//		GridLayout glTop = new GridLayout(1, false);
//		_top.setLayout(glTop);
//
//		GridData gdGrpEin = new GridData();
//		gdGrpEin.grabExcessHorizontalSpace = true;
//		gdGrpEin.horizontalAlignment = GridData.FILL;
//		gdGrpEin.grabExcessVerticalSpace = true;
//		gdGrpEin.verticalAlignment = GridData.FILL;
//		_grpEin.setLayoutData(gdGrpEin);
//
//		GridLayout glGrpEin = new GridLayout(2, false);
//		glGrpEin.numColumns = 4;
//		_grpEin.setLayout(glGrpEin);
//
//		GridData gdTextServer = new GridData();
//		gdTextServer.grabExcessHorizontalSpace = true;
//		gdTextServer.horizontalAlignment = GridData.FILL;
//		_textDatei.setLayoutData(gdTextServer);
//
//		GridData gdTextUser = new GridData();
//		// gdTextUser.grabExcessHorizontalSpace = true;
//		// gdTextUser.horizontalAlignment = GridData.FILL;
//		gdTextUser.minimumWidth = 0;
////		_compositeZeitDauer.setLayoutData(gdTextUser);
//
//		// GridData gdTextPasswd = new GridData();
//		// gdTextPasswd.grabExcessHorizontalSpace = true;
//		// gdTextPasswd.horizontalAlignment = GridData.FILL;
//		// _textPasswd.setLayoutData(gdTextPasswd);
//		
//    GridData gdGrpBasis = new GridData();
//    gdGrpBasis.grabExcessHorizontalSpace = true;
//    gdGrpBasis.horizontalAlignment = GridData.FILL;
//    // gdGrpBasis.grabExcessVerticalSpace = true;
//    // gdGrpBasis.verticalAlignment = GridData.FILL;
//    _grpBasis.setLayoutData(gdGrpBasis);
//
//    GridLayout glGrpBasis = new GridLayout(2, false);
//    glGrpBasis.numColumns = 4;
//    _grpBasis.setLayout(glGrpBasis);
//
//    GridData gdTextBasis = new GridData();
//    gdTextBasis.grabExcessHorizontalSpace = true;
//    gdTextBasis.horizontalAlignment = GridData.FILL;
//    _textVerzeichnis.setLayoutData(gdTextBasis);
//		
//
//		/*
//		 * Defaultwerte setzen
//		 */
//		actionLoadFromPreferenceStore();

		return null;
	}

	/**
	 * Stellt die Default-Einstellungen aus den Prferenzen wieder her.
	 */
	private void actionLoadDefaultsFromPreferenceStore() {

		// Preferences preferences =
		// Activator.getDefault().getPluginPreferences();

		boolean soundEinAus = getPreferenceStore().getBoolean(
				DefsPara.SoundEinAus);
		String pfad = getPreferenceStore().getString(DefsPara.DateiName);
		Long intervall = getPreferenceStore().getLong(DefsPara.Intervall);

		if (_chkSoundVerwenden != null) {
			_chkSoundVerwenden.setSelection(soundEinAus);
		}
		if (_textDatei != null) {
			_textDatei.setText("" + pfad);
		}
//		if (_compositeZeitDauer != null) {
//			_compositeZeitDauer
//					.setZeitDauerInBezugAufAnfangsZeitpunkt(intervall);
//		}
	}

	/**
	 * Stellt die Einstellungen aus den Prferenzen wieder her. Wenn keine
	 * gesetzt wurden, werden die Defaulteinstellungen wiederhergestellt.
	 */
	private void actionLoadFromPreferenceStore() {

		// Preferences preferences =
		// Activator.getDefault().getPluginPreferences();
		
		boolean ftpEinAus = getPreferenceStore().getBoolean(
				DefsPara.SoundEinAus);
		String server = getPreferenceStore().getString(DefsPara.DateiName);
		Long intervall = getPreferenceStore().getLong(DefsPara.Intervall);

		if (_chkSoundVerwenden != null) {
			_chkSoundVerwenden.setSelection(ftpEinAus);
		}
		if (_textDatei != null) {
			_textDatei.setText("" + server);
		}
//		 if (_compositeZeitDauer != null) {
//		 _compositeZeitDauer.setZeitDauerInBezugAufAnfangsZeitpunkt(intervall);
//		 }

		if (!ftpEinAus) {
			_textDatei.setEnabled(false);
//			_compositeZeitDauer.setEnabled(false);
			_button.setEnabled(false);
		}

	}

	/**
	 * Speichert die i.d. PreferencePage gemachten Einstellungen in den
	 * Prferenzen
	 */
	private void actionSaveToPreferenceStore() {
		boolean soundEinAus = false;
		String pfad = "";
		Long intervall = 0L;
		String passwd = "";

		/*
		 * Zeigt an, ob alle Werte aus den Feldern geholt werden konnten.
		 */
		boolean allValuesAvailable = true;

		if (_chkSoundVerwenden != null) {
			soundEinAus = _chkSoundVerwenden.getSelection();
		} else {
			allValuesAvailable = false;
		}

		if (soundEinAus) {
			if (_textDatei != null) {
				pfad = _textDatei.getText();
				try {
					File file = new File(pfad);
					if (!file.exists())
						allValuesAvailable = false;

				} catch (Exception e) {
					allValuesAvailable = false;

					String message = "Die in den Sound-Preferences angegebene Datei-Pfad \""
							+ pfad + "\" ist formal nicht korrekt.";

					MessageBox mb = new MessageBox(PlatformUI.getWorkbench()
							.getDisplay().getActiveShell(), SWT.OK
							| SWT.ICON_ERROR);
					mb.setText("Ungltige IP");
					mb.setMessage(message);
					mb.open();
				}
			} else {
				allValuesAvailable = false;
			}
//			if (_compositeZeitDauer != null) {
//				intervall = _compositeZeitDauer.getZeitDauer();
//
//				if ((intervall != null) && (intervall > 0)) {
//
//				} else {
//					allValuesAvailable = false;
//
//					String message = "Das im Login-Dialog angegebene Intervall ist nicht gltig!";
//
//					MessageBox mb = new MessageBox(PlatformUI.getWorkbench()
//							.getDisplay().getActiveShell(), SWT.OK
//							| SWT.ICON_ERROR);
//					mb.setText("Benutzerfeld nicht ausgefllt");
//					mb.setMessage(message);
//					mb.open();
//				}
//
//			} else {
//				allValuesAvailable = false;
//			}
		}

		if (allValuesAvailable) {
			// Preferences preferences =
			// Activator.getDefault().getPluginPreferences();
			
			getPreferenceStore().setValue(DefsPara.SoundEinAus, soundEinAus);
			if (soundEinAus) {
				getPreferenceStore().setValue(DefsPara.DateiName, pfad);
				getPreferenceStore().setValue(DefsPara.Intervall, intervall);
			}
		}

	}

	@Override
	protected void performApply() {
//		actionSaveToPreferenceStore();
	}

	@Override
	public boolean performCancel() {
		return super.performCancel();
	}

	@Override
	protected void performDefaults() {
//		actionLoadDefaultsFromPreferenceStore();
		super.performDefaults();
	}

	@Override
	public boolean performOk() {
		performApply();
		return super.performOk();
	}

	@Override
	public void init(IWorkbench workbench) {
	}

	@Override
	public void performHelp() {
		String helpContextId = Activator.PLUGIN_ID + ".preferencepage";
		IWorkbenchHelpSystem helpSystem = PlatformUI.getWorkbench().getHelpSystem();
//		helpSystem.displayHelp(helpContextId);
//		helpSystem.displayHelp(helpContextId);
	}

}
