/*
 * This file is part of Rahmenwerk.
 *
 * Rahmenwerk is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License  as 
 * published by the Free Software Foundation, either version 3 of the
 * License.
 *
 * Rahmenwerk is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with Rahmenwerk.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * 
 *
 * Copyright (c) 2011 SWARCO TRAFFIC SYSTEMS GmbH.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 * SWARCO TRAFFIC SYSTEMS GmbH - initial API and implementation
 *
 *
 *
 * Contact Information:
 * SWARCO TRAFFIC SYSTEMS GmbH
 * Adolf-Dambach-Strae 
 * D-76571 Gaggenau
 * Phone: +49-7225-64-03
 * Fax: +49-7225-64-300
 * mailto: office.sts@swarco.de
 */

package de.bsvrz.buv.plugin.tkabasis.aktionen;

/**
 * Die Klasse implementiert die Aktionsfabrik fr die TKABasis
 * 
 * @author Krause
 *
 */
public class AktionFactory
{
  /**
   * ID von dieser Klasse
   */
  public static final String ID = "de.bsvrz.buv.plugin.tkabasis.aktionen.aktionFactory";
  
  public static enum TKABasisAktion {
    NEU(0, ID + ".neuesHO"), 
    NEUUO(1, ID + ".neuesHOuO"), 
    KOPIERENHO(2, ID + ".kopierenHO"), 
    KOPIERENHOMUO(3, ID + ".kopierenHOmuO"), 
    VERSCHIEBEN(4, ID + ".verschiebenHO"), 
    LOESCHEN(5, ID + ".loeschenHO"), 
    SELEKTIEREN(6, ID + ".selektierenHO"), 
    DARSTELLEN(7, ID + ".darstellenHO"), 
    BEARBEITEN(8, ID + ".bearbeitenHO"), 
    VORGAENGER(9, ID + ".vorgaengerHO"), 
    VORGAENGEREBENE(10, ID + ".vorgaengerEbeneHO"), 
    NACHFOLGER(11, ID + ".nachfolgerHO"), 
    NACHFOLGEREBENE(12, ID + ".nachfolgerEbeneHO"), 
    DEFAULT(13, ID + ".defaultHO"), 
    PRUEFEN(14, ID + ".pruefenHO"), 
    UEBERNEHMEN(15, ID + ".uebernehmenHO"), 
    ABBRUCH(16, ID + ".abbruch"), 
    KOPIEREN(17, ID + ".kopieren"), 
    EINFUEGEN(18, ID + ".einfuegen"),
    EINFUEGENVER(19, ID + ".einfuegenVerschiebung"),
    KONFIGAENDERUNGINFO(20, ID + ".konfigAenderungInfo"),
    SOINFO(21, ID + ".SOInfo");
    
    private Aktion _aktion;
    
    private TKABasisAktion(Integer nr, String id)
    {
      _aktion = new Aktion(nr, id);
    }
     
    public Aktion getAktion()
    {
      return _aktion;
    }
    
    public static Integer getAktionsNr(String id)
    {
      TKABasisAktion[] aktionen = TKABasisAktion.values();
      
      for (int i = 0; i < aktionen.length; i++)
      {
        Aktion aktion = aktionen[i].getAktion();
        String aktionsId = aktion.getAktionsID();
        if ( aktionsId.equals(id))
          return aktion.getAktionsNr();
      }
            
      return null;
    }
    
  };
   
  public AktionFactory()
  {
    // TODO Auto-generated constructor stub
  }


}
