/*
 * This file is part of Rahmenwerk.
 *
 * Rahmenwerk is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License  as 
 * published by the Free Software Foundation, either version 3 of the
 * License.
 *
 * Rahmenwerk is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with Rahmenwerk.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * 
 *
 * Copyright (c) 2011 SWARCO TRAFFIC SYSTEMS GmbH.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 * SWARCO TRAFFIC SYSTEMS GmbH - initial API and implementation
 *
 *
 *
 * Contact Information:
 * SWARCO TRAFFIC SYSTEMS GmbH
 * Adolf-Dambach-Strae 
 * D-76571 Gaggenau
 * Phone: +49-7225-64-03
 * Fax: +49-7225-64-300
 * mailto: office.sts@swarco.de
 */

package de.bsvrz.buv.plugin.tkabasis.hierarchie;

import de.bsvrz.dav.daf.main.config.ConfigurationArea;

/**
 * Benachrichtigung ber nderungen an einer Instanz vom Typ IHierarchie.<br>
 * Es werden die in EVENT enthaltenen Ereignisse fr Objekte vom Typ HierarchieObjekt
 * benachrichtigt.
 * 
 * @author Sans
 *
 */
public interface IHierarchieBeobachter
{
  /**
   * Die mglichen nderungs-Aktualisierungsereignisse
   * @author Sans
   *
   */
  public enum EVENT { OBJEKT_NEU, OBJEKT_ENTFERNT, OBJEKT_AKTUALISIERT, OBJEKT_VERSCHOBEN };
  
  /**
   * Benachrichtigung ber nderungen an einer Instanz vom Typ KBHierarchie
   * 
   * @param event Aktualisierungsereigniss
   * @param kb Das Wurzelobjekt, unterhalb dieses Objekts hat die Aktualisierung stattgefunden
   * @param vater das unmittelbar bergeordnete Objekt des Aktualisierungsereignisses
   * @param ho Das Hierarchieobjekt, das die Benachrichtigung betrifft
   */
  public void hierarchieAktualisiert(EVENT event, ConfigurationArea kb, Object vater, HierarchieObjekt ho);
  
}
