/*
 * This file is part of Rahmenwerk.
 *
 * Rahmenwerk is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License  as 
 * published by the Free Software Foundation, either version 3 of the
 * License.
 *
 * Rahmenwerk is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with Rahmenwerk.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * 
 *
 * Copyright (c) 2011 SWARCO TRAFFIC SYSTEMS GmbH.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 * SWARCO TRAFFIC SYSTEMS GmbH - initial API and implementation
 *
 *
 *
 * Contact Information:
 * SWARCO TRAFFIC SYSTEMS GmbH
 * Adolf-Dambach-Strae 
 * D-76571 Gaggenau
 * Phone: +49-7225-64-03
 * Fax: +49-7225-64-300
 * mailto: office.sts@swarco.de
 */

package de.bsvrz.buv.plugin.tkatls;


import org.eclipse.jface.action.Action;
import org.eclipse.jface.action.IAction;
import org.eclipse.ui.IStartup;
import org.eclipse.ui.IWorkbenchPage;
import org.eclipse.ui.IWorkbenchWindow;
import org.eclipse.ui.PartInitException;
import org.eclipse.ui.PlatformUI;

import de.bsvrz.buv.plugin.tkabasis.TKABasisComposite;
import de.bsvrz.buv.plugin.tkabasis.TKABasisView;
import de.bsvrz.buv.rw.rw.menu.ElementRegistrierung;
import de.bsvrz.buv.rw.rw.menu.deskriptoren.DeskriptorAktion;
import de.bsvrz.puk.config.configFile.datamodel.ConfigDataModel;
import de.bsvrz.sys.funclib.debug.Debug;

/**
 * {@link IStartup} Implementierung, registriert alle Actions dieses Moduls zwecks Men- und Symbolleistenaufbau bzw.
 * deren Verwaltung.
 * 
 * @version $Revision: 1.13 $ / $Date: 2011/01/17 14:11:56 $ / ($Author: Sans $)
 * 
 * @author HofmannJ
 * 
 */
public class Starter implements IStartup
{
  /**
   * Der Debugger
   */
  private Debug _debug = Debug.getLogger();

  /**
   * Der Zaehler fr die Views
   */
  private int _numViewInstances = 0;

  /**
   * In dieser Methode werden die vom Modul Betriebsmeldungsverwaltung bereitgestellten Actions generiert und in der
   * Klasse {@link ElementRegistrierung} ber deren Methode
   * {@link ElementRegistrierung#registriereDeskriptorAktion(de.bsvrz.buv.rw.rw.menu.deskriptoren.DeskriptorAktion)}
   * registriert.
   */
  public void earlyStartup()
  {
    _debug.config("Modul TKA-TLS ist geladen.");
//    IAction action = new Action() {
//      public void run()
//      {
//        IWorkbenchWindow dw = PlatformUI.getWorkbench().getActiveWorkbenchWindow();
//        IWorkbenchPage page = dw.getActivePage();
//
//        try
//        {
//          starteView(page);
//        }
//        catch (PartInitException e)
//        {
//          // TODO Auto-generated catch block
//          e.printStackTrace();
//        }
//      }
//    };
//    action.setText("TKA-TLS");
//    action.setId("de.bsvrz.buv.plugin.tkatls");
//
//    DeskriptorAktion deskriptorAktion = new DeskriptorAktion("de.bsvrz.buv.plugin.tkatls", action, true);
//
//    ElementRegistrierung.getInstanz().registriereDeskriptorAktionGlobal(deskriptorAktion);

  }

//  private void starteView(IWorkbenchPage page) throws PartInitException
//  {
//    System.out.println("Starter.starteView() TLS");
//   
//    String id = TKABasisView.ID;
//    
//    TKABasisView view = (TKABasisView)page.showView(id, "TLS", IWorkbenchPage.VIEW_VISIBLE);
//    DatenSpeicher.getInstanz().setzeTKABasisView(view);
//    
////    TKABasisView view = DatenSpeicher.getInstanz().holeTKABasisView();
//    
//    ConfigDataModel dataModel = DatenSpeicher.getInstanz().holeConfigDataModel();
//    
//    String pfad = DatenSpeicher.getInstanz().holeDateiPfad();
//    
//  	if (DatenSpeicher.getInstanz().getHierarchieManager() == null)
//		{
//			DatenSpeicher.getInstanz().setHierarchieManager(new HierachieManagerTLS());
//		}
//		
////		if (DatenSpeicher.getInstanz().getBildungsRegeln() == null)
////		{
////			String klassenName = Activator.getDefault().getPreferenceStore().getString(DefsPara.KlasseBildungsregeln);
////			IBildungsRegeln bildungsRegeln = TKATlsViewKapsel.ladeBildungsRegeln(klassenName, null);
////			
////			if (bildungsRegeln != null)
////			{
////				DatenSpeicher.getInstanz().setBildungsRegeln(bildungsRegeln);
////			}
////		}
//    
//		view.setModelInfo(DatenSpeicher.getInstanz());
//    
//    TKABasisComposite tkaComposite = view.getTkaComposite();
//    
//    tkaComposite.setConfigDataModel(dataModel, pfad);
//    
//    
////    IConfigurationElement[] configurationElementsFor = Platform.getExtensionRegistry().getConfigurationElementsFor(
////        "de.bsvrz.buv.plugin.tkabasis.tkaBasisComposite");
////
////    for (IConfigurationElement ce : configurationElementsFor)
////    {
////      try
////      {
////        String name = ce.getName();
////
////        if (name.equals("tkaBasisComposite"))
////        {
////          Object ext = ce.createExecutableExtension("tkaBasisCompositeKlasse");
////
////          System.out.println(ext.getClass().getName());
////
////          ITKABasisComposite iView = (ITKABasisComposite)ext;
////          TKABasisView view = (TKABasisView)iView;
////
////          IWorkbenchWindow dw = PlatformUI.getWorkbench().getActiveWorkbenchWindow();
////          page = dw.getActivePage();
////          String secID = "TKA-TLS";
////          page.showView(view.ID, secID, IWorkbenchPage.VIEW_VISIBLE);
////
////          break;
////        }
////
////      }
////      catch (CoreException ec)
////      {
////        // TODO Auto-generated catch block
////        ec.printStackTrace();
////      }
////    }
//  }
}
